<?php

if(!defined("IN_MYBB"))
{
    die("You cannot directly access this file.");
}

// Plugin Hooks

$plugins->add_hook("home_announcement", "mybbhome");

// Plugin Information

function mybbhome_info()
{
	return array(
		"name"			=> "MyBB Home (Pro Portal)",
		"description"	=> "Get the latest updates in terms of new discussion, threads, posts on the forum, and new Private Messages received",
		"website"		=> "http://www.mybb.vn",
		"version"		=> "1.0",
		"author"		=> "TamNguyen949",
		"authorsite"	=> "http://www.mybb.vn/community/member.php?action=profile&uid=440",
		"compatibility" => "16*",
		'guid'          => ''
	);
}

// Plugin Activation
function mybbhome_activate()
{
 require MYBB_ROOT.'/inc/adminfunctions_templates.php';
 global $db, $mybb, $settings;

	$settings_home = array(
        'gid'          => 'NULL',
        'name'         => 'mybbhomeacpst',
        'title'        => 'MyBB Home (Pro Portal)',
        'description'  => 'MyBB Home Plugin Settings.',
        'disporder'    => '2',
        'isdefault'    => 'no'
	);	
	
    $db->insert_query('settinggroups', $settings_home);
    $gid = $db->insert_id();

	$mybbhome1 = array('name' => 'home_announcementsfid','title' =>'Forum ID to pull announcements from','description' =>'Please enter the forum ids (fid) of the forum(s) you wish to pull the announcements from. Separate them with a comma (,).','optionscode' => 'text','value' =>'2','disporder' => 1,'gid' => intval($gid));
	$mybbhome2 = array('name' => 'home_numannouncements','title' =>'Number of announcements to show','description' =>'Please enter the number of announcements to show on the main page.','optionscode' => 'text','value' =>'10','disporder' => 2,'gid' => intval($gid));
	$mybbhome3 = array('name' => 'home_messagescutoff','title' =>'Home Announcement Cut Off','description' =>'Set a minimum of characters for home announcements?','optionscode' => 'onoff','value' =>'1','disporder' => 3,'gid' => intval($gid));
	$mybbhome4 = array('name' => 'home_characters','title' =>'Characters Announcement','description' =>'Number of characters before the announcement is cut off','optionscode' => 'text','value' =>'300','disporder' => 4,'gid' => intval($gid));
	$mybbhome5 = array('name' => 'home_cutoffmessage','title' =>'Announcement Cut Off Message','description' =>'Message to be displayed when announcemet is cut off','optionscode' => 'text','value' =>'..... More','disporder' => 5,'gid' => intval($gid));
    $mybbhome6 = array('name' => 'home_showwelcome','title' =>'Show the Welcome box','description' =>'Do you want to show the welcome box to visitors / users.','optionscode' => 'onoff','value' =>'1','disporder' => 6,'gid' => intval($gid));
	$mybbhome7 = array('name' => 'home_showpms','title' =>'Show the number of PMs to users','description' =>'Do you want to show the number of private messages the current user has in their pm system.','optionscode' => 'onoff','value' =>'1','disporder' => 7,'gid' => intval($gid));
	$mybbhome8 = array('name' => 'home_showstats','title' =>'Show forum statistics','description' =>'Do you want to show the total number of posts, threads, members and the last registered member on the home page?','optionscode' => 'onoff','value' =>'1','disporder' => 8,'gid' => intval($gid));
    $mybbhome9 = array('name' => 'home_showwol','title' =>'Show Who is Online','description' =>'Do you want to show the "Who is online" information to users when they visit the home page?','optionscode' => 'onoff','value' =>'1','disporder' => 9,'gid' => intval($gid));
	$mybbhome10 = array('name' => 'home_showsearch','title' =>'Show Search Box','description' =>'Do you want to show the search box, allowing users to quickly search the forums on the home?','optionscode' => 'onoff','value' =>'1','disporder' => 11,'gid' => intval($gid));
	$mybbhome11 = array('name' => 'home_showdiscussions','title' =>'Show Latest Threads','description' =>'Do you wish to show the current forum threads on the home page?','optionscode' => 'onoff','value' =>'1','disporder' => 11,'gid' => intval($gid));
	$mybbhome12 = array('name' => 'home_showdiscussionsnum','title' =>'Number of latest threads to show','description' =>'Please enter the number of current forum threads to show on the home page.','optionscode' => 'text','value' =>'10','disporder' => 12,'gid' => intval($gid));
	$mybbhome13 = array('name' => 'home_latestthreadscharacters','title' =>'Latest threads subject characters','description' =>'Number of characters before the latest threads subject is cut off','optionscode' => 'text','value' =>'25','disporder' => 13,'gid' => intval($gid));
	$db->insert_query('settings',$mybbhome1);
    $db->insert_query('settings',$mybbhome2);
	$db->insert_query('settings',$mybbhome3);
	$db->insert_query('settings',$mybbhome4);
	$db->insert_query('settings',$mybbhome5);
	$db->insert_query('settings',$mybbhome6);
	$db->insert_query('settings',$mybbhome7);
	$db->insert_query('settings',$mybbhome8);
	$db->insert_query('settings',$mybbhome9);
	$db->insert_query('settings',$mybbhome10);
	$db->insert_query('settings',$mybbhome11);
	$db->insert_query('settings',$mybbhome12);
	$db->insert_query('settings',$mybbhome13);
    rebuildsettings();
	
	$mybbhome_template1 = array(
		"title"       => "home",
		"template"    => "
<html>
<head>
<title>{\$mybb->settings[\'bbname\']}</title>
{\$headerinclude}
</head>
<body>
{\$header}
<table width=\"100%\" cellspacing=\"0\" cellpadding=\"{\$theme[\'tablespace\']}\" border=\"0\" align=\"center\">
<tr><td valign=\"top\">
{\$announcements}
{\$multipage}
</td>
<td>&nbsp;</td>
<td valign=\"top\" width=\"200\">
{\$welcome}
{\$pms}
{\$latestthreads}
{\$search}
{\$stats}
{\$whosonline}
</td>
</tr>
</table>
<table width=\"100%\" cellspacing=\"0\" cellpadding=\"0\" border=\"0\" align=\"center\">
<tr>
<td align=\"center\" width=\"100%\" class=\"smalltext\"><a href=\"http://www.mybb.vn/\" target=\"_blank\">MyBB Home 1.0</a> &copy; 2012 <a href=\"http://www.mybb.vn/community/member.php?action=profile&uid=440\" target=\"_blank\">TamNguyen949</a></td>
</tr>
</table>
{\$footer}
</body>
</html>
		",
		"sid"           => "-1",
		"version"	     => "1.0",
		"dateline"	     => "1157735635",
	);
	$mybbhome_template2 = array(
		"title"       => "home_announcement",
		"template"    => "
<table cellspacing=\"{\$theme[\'borderwidth\']}\" cellpadding=\"{\$theme[\'tablespace\']}\" class=\"tborder\">
<tr>
<td class=\"thead\"><strong>{\$icon} <a href=\"{\$mybb->settings[\'bburl\']}/{\$announcement[\'threadlink\']}\">{\$announcement[\'subject\']}</a></strong></td>
</tr>
<tr>
<td class=\"trow2\" align=\"right\">
<span class=\"smalltext\">{\$lang->posted_by} {\$profilelink}  - {\$anndate} {\$anntime} {\$numcomments}</span>
</td>
</tr>
<tr>
<td class=\"trow1\">
<table border=\"0\" cellpadding=\"{\$theme[\'tablespace\']}\" width=\"100%\">
	<tr>
		{\$avatar}
		<td class=\"trow1\">
			<p>
				{\$message}
			</p>
			{\$post[\'attachments\']}
		</td>
	</tr>
	<tr>
		<td align=\"right\" colspan=\"2\" valign=\"bottom\">
			<span class=\"smalltext\">
				<a href=\"{\$mybb->settings[\'bburl\']}/printthread.php?tid={\$announcement[\'tid\']}\"><img src=\"{\$theme[\'imgdir\']}/printable.gif\" alt=\"{\$lang->print_this_item}\" title=\"{\$lang->print_this_item}\" /></a>&nbsp;<a href=\"{\$mybb->settings[\'bburl\']}/sendthread.php?tid={\$announcement[\'tid\']}\"><img src=\"{\$theme[\'imgdir\']}/send.gif\" alt=\"{\$lang->send_to_friend}\" title=\"{\$lang->send_to_friend}\" /></a>
			</span>
		</td>
	</tr>
</table>
</td>
</tr>
</table>
<br />
	",
		"sid"           => "-1",
		"version"	     => "1.0",
		"dateline"	     => "1157735635",
	);
	$mybbhome_template3 = array(
		"title"       => "home_announcement_numcomments",
		"template"    => "
- <a href=\"{\$mybb->settings[\'bburl\']}/{\$announcement[\'threadlink\']}\">{\$lang->replies}</a> ({\$announcement[\'replies\']})
		",
		"sid"           => "-1",
		"version"	     => "1.0",
		"dateline"	     => "1157735635",
	);
	$mybbhome_template4 = array(
		"title"       => "home_announcement_numcomments_no",
		"template"    => "
- {\$lang->no_replies}
		",
		"sid"           => "-1",
		"version"	     => "1.0",
		"dateline"	     => "1157735635",
	);
	$mybbhome_template5 = array(
		"title"       => "home_latestthreads",
		"template"    => "
<table border=\"0\" cellspacing=\"{\$theme[\'borderwidth\']}\" cellpadding=\"{\$theme[\'tablespace\']}\" class=\"tborder\">
<tr>
<td class=\"thead\"><strong>{\$lang->latest_threads}</strong></td>
</tr>
{\$threadlist}
</table>
<br />
		",
		"sid"           => "-1",
		"version"	     => "1.0",
		"dateline"	     => "1157735635",
	);
	$mybbhome_template6 = array(
		"title"       => "home_latestthreads_thread",
		"template"    => "
<tr>
<td class=\"{\$altbg}\">
<strong><a href=\"{\$mybb->settings[\'bburl\']}/{\$thread[\'threadlink\']}\">{\$thread[\'subject\']}</a></strong>
<span class=\"smalltext\"><br />
<a href=\"{\$thread[\'lastpostlink\']}\">{\$lang->latest_threads_lastpost}</a> {\$lastposterlink}<br />
{\$lastpostdate} {\$lastposttime}<br />
<strong>&raquo; </strong>{\$lang->latest_threads_replies} {\$thread[\'replies\']}<br />
<strong>&raquo; </strong>{\$lang->latest_threads_views} {\$thread[\'views\']}
</span>
</td>
</tr>
		",
		"sid"           => "-1",
		"version"	     => "1.0",
		"dateline"	     => "1157735635",
	);
	$mybbhome_template7 = array(
		"title"       => "home_pms",
		"template"    => "
<table border=\"0\" cellspacing=\"{\$theme[\'borderwidth\']}\" cellpadding=\"{\$theme[\'tablespace\']}\" class=\"tborder\">
<tr>
<td class=\"thead\"><strong><a href=\"{\$mybb->settings[\'bburl\']}/private.php\">{\$lang->private_messages}</a></strong></td>
</tr>
<tr>
<td class=\"trow1\">
<span class=\"smalltext\">{\$lang->pms_received_new}<br /><br />
<strong>&raquo; </strong> <strong>{\$messages[\'pms_unread\']}</strong> {\$lang->pms_unread}<br />
<strong>&raquo; </strong> <strong>{\$messages[\'pms_total\']}</strong> {\$lang->pms_total}</span>
</td>
</tr>
</table>
<br />
		",
		"sid"           => "-1",
		"version"	     => "1.0",
		"dateline"	     => "1157735635",
	);
	$mybbhome_template8 = array(
		"title"       => "home_search",
		"template"    => "
<table border=\"0\" cellspacing=\"{\$theme[\'borderwidth\']}\" cellpadding=\"{\$theme[\'tablespace\']}\" class=\"tborder\">
<tr>
<td class=\"thead\"><strong>{\$lang->search_forums}</strong></td>
</tr>
<tr>
<td class=\"trow1\" align=\"center\">
<form method=\"post\" action=\"{\$mybb->settings[\'bburl\']}/search.php\">
<input type=\"hidden\" name=\"action\" value=\"do_search\" />
<input type=\"hidden\" name=\"postthread\" value=\"1\" />
<input type=\"hidden\" name=\"forums\" value=\"all\" />
<input type=\"hidden\" name=\"showresults\" value=\"threads\" />
<input type=\"text\" class=\"textbox\" name=\"keywords\" value=\"\" />
{\$gobutton}
</form><br />
<span class=\"smalltext\">
(<a href=\"{\$mybb->settings[\'bburl\']}/search.php\">{\$lang->advanced_search}</a>)
</span>
</td>
</tr>
</table>
<br />
		",
		"sid"           => "-1",
		"version"	     => "1.0",
		"dateline"	     => "1157735635",
	);
	$mybbhome_template9 = array(
		"title"       => "home_stats",
		"template"    => "
<table border=\"0\" cellspacing=\"{\$theme[\'borderwidth\']}\" cellpadding=\"{\$theme[\'tablespace\']}\" class=\"tborder\">
<tr>
<td class=\"thead\"><strong>{\$lang->forum_stats}</strong></td>
</tr>
<tr>
<td class=\"trow1\">
<span class=\"smalltext\">
<strong>&raquo; </strong>{\$lang->num_members} {\$stats[\'numusers\']}<br />
<strong>&raquo; </strong>{\$lang->latest_member} {\$newestmember}<br />
<strong>&raquo; </strong>{\$lang->num_threads} {\$stats[\'numthreads\']}<br />
<strong>&raquo; </strong>{\$lang->num_posts} {\$stats[\'numposts\']}
<br /><br /><a href=\"{\$mybb->settings[\'bburl\']}/stats.php\">{\$lang->full_stats}</a>
</span>
</td>
</tr>
</table>
<br />
		",
		"sid"           => "-1",
		"version"	     => "1.0",
		"dateline"	     => "1157735635",
	);
	$mybbhome_template10 = array(
		"title"       => "home_welcome",
		"template"    => "
<table border=\"0\" cellspacing=\"{\$theme[\'borderwidth\']}\" cellpadding=\"{\$theme[\'tablespace\']}\" class=\"tborder\">
<tr>
<td class=\"thead\"><strong>{\$lang->welcome}</strong></td>
</tr>
<tr>
<td class=\"trow1\">
{\$welcometext}
</td>
</tr>
</table><br />
		",
		"sid"           => "-1",
		"version"	     => "1.0",
		"dateline"	     => "1157735635",
	);
	$mybbhome_template11 = array(
		"title"       => "home_welcome_guesttext",
		"template"    => "
<span class=\"smalltext\">{\$lang->guest_welcome_registration}</span><br />
<br />
<form method=\"post\" action=\"{\$portal_url}\"><input type=\"hidden\" name=\"action\" value=\"do_login\" />
{\$username}<br />&nbsp;&nbsp;<input type=\"text\" class=\"textbox\" name=\"username\" value=\"\" /><br /><br />
{\$lang->password}<br />&nbsp;&nbsp;<input type=\"password\" class=\"textbox\" name=\"password\" value=\"\" /><br /><br />
<label title=\"{\$lang->remember_me_desc}\"><input type=\"checkbox\" class=\"checkbox\" name=\"remember\" value=\"yes\" /> {\$lang->remember_me}</label><br /><br />
<br /><input type=\"submit\" class=\"button\" name=\"loginsubmit\" value=\"{\$lang->login}\" /></form>
		",
		"sid"           => "-1",
		"version"	     => "1.0",
		"dateline"	     => "1157735635",
	);
	$mybbhome_template12 = array(
		"title"       => "home_welcome_membertext",
		"template"    => "
<span class=\"smalltext\"><em>{\$lang->member_welcome_lastvisit}</em> {\$lastvisit}<br />
{\$lang->since_then}<br />
<strong>&raquo;</strong> {\$lang->new_announcements}<br />
<strong>&raquo;</strong> {\$lang->new_threads}<br />
<strong>&raquo;</strong> {\$lang->new_posts}<br /><br />
<a href=\"{\$mybb->settings[\'bburl\']}/search.php?action=getnew\">{\$lang->view_new}</a><br /><a href=\"{\$mybb->settings[\'bburl\']}/search.php?action=getdaily\">{\$lang->view_todays}</a>
</span>
		",
		"sid"           => "-1",
		"version"	     => "1.0",
		"dateline"	     => "1157735635",
	);
	$mybbhome_template13 = array(
		"title"       => "home_whosonline",
		"template"    => "
<table border=\"0\" cellspacing=\"{\$theme[\'borderwidth\']}\" cellpadding=\"{\$theme[\'tablespace\']}\" class=\"tborder\">
<tr>
<td class=\"thead\"><strong>{\$lang->online}</strong></td>
</tr>
<tr>
<td class=\"trow1\">
<span class=\"smalltext\">
{\$lang->online_users}<br /><strong>&raquo;</strong> {\$lang->online_counts}<br />{\$onlinemembers}
</span>
</td>
</tr>
</table>
<br />
		",
		"sid"           => "-1",
		"version"	     => "1.0",
		"dateline"	     => "1157735635",
	);
	$mybbhome_template14 = array(
		"title"       => "home_whosonline_memberbit",
		"template"    => "
{\$comma}<a href=\"{\$mybb->settings[\'bburl\']}/{\$user[\'profilelink\']}\">{\$user[\'username\']}</a>{\$invisiblemark}
		",
		"sid"           => "-1",
		"version"	     => "1.0",
		"dateline"	     => "1157735635",
	);
	
	$db->insert_query("templates", $mybbhome_template1);
	$db->insert_query("templates", $mybbhome_template2);
	$db->insert_query("templates", $mybbhome_template3);
	$db->insert_query("templates", $mybbhome_template4);
	$db->insert_query("templates", $mybbhome_template5);
	$db->insert_query("templates", $mybbhome_template6);
	$db->insert_query("templates", $mybbhome_template7);
	$db->insert_query("templates", $mybbhome_template8);
	$db->insert_query("templates", $mybbhome_template9);
	$db->insert_query("templates", $mybbhome_template10);
	$db->insert_query("templates", $mybbhome_template11);
	$db->insert_query("templates", $mybbhome_template12);
	$db->insert_query("templates", $mybbhome_template13);
	$db->insert_query("templates", $mybbhome_template14);
}

// Plugin DeActivation
function mybbhome_deactivate()
{
    require MYBB_ROOT.'/inc/adminfunctions_templates.php';
    global $db;
    $db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name IN('home_announcementsfid', 'mybbhomeacpst')");
    $db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name IN('home_numannouncements', 'mybbhomeacpst')");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name IN('home_messagescutoff', 'mybbhomeacpst')");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name IN('home_characters', 'mybbhomeacpst')");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name IN('home_cutoffmessage', 'mybbhomeacpst')");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name IN('home_showwelcome', 'mybbhomeacpst')");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name IN('home_showpms', 'mybbhomeacpst')");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name IN('home_showstats', 'mybbhomeacpst')");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name IN('home_showwol', 'mybbhomeacpst')");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name IN('home_showsearch', 'mybbhomeacpst')");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name IN('home_showdiscussions', 'mybbhomeacpst')");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name IN('home_showdiscussionsnum', 'mybbhomeacpst')");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name IN('home_latestthreadscharacters', 'mybbhomeacpst')");
	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title='home'");
	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title='home_announcement'");
	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title='home_announcement_numcomments'");
	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title='home_announcement_numcomments_no'");
	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title='home_latestthreads'");
	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title='home_latestthreads_thread'");
	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title='home_pms'");
	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title='home_search'");
	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title='home_stats'");
	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title='home_welcome'");
	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title='home_welcome_guesttext'");
	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title='home_welcome_membertext'");
	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title='home_whosonline'");
	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title='home_whosonline_memberbit'");
    $db->query("DELETE FROM ".TABLE_PREFIX."settinggroups WHERE name='mybbhomeacpst'");
    rebuildsettings();
}

function mybbhome()	
{
global $mybb, $announcement;

if($mybb->settings['home_messagescutoff'] == 1 AND $mybb->settings['home_characters'] < my_strlen($announcement['message'])){
$announcement['message'] = my_substr($announcement['message'], 0, $mybb->settings['home_characters']);
$announcement['message'] .= "[url=".$mybb->settings['bburl']."/".$announcement['threadlink']."]".$mybb->settings['home_cutoffmessage']."[/url]";
}
}

?>